Summary: A daemon using the Sophos SAV Interface
Name: sophie
Version: 3.04rc1
Release: 1
License: GPL
Group: Applications/Communications
URL: http://www.vanja.com/tools/sophie/
Source: http://www.vanja.com/tools/sophie/sophie-%{version}.tar.bz2
Source1: sophie.init
Packager: Tim Jackson <tim@timj.co.uk>
BuildRoot: /var/tmp/%{name}-buildroot

%description 
Sophie is a daemon which uses the 'libsavi' library from the Sophos anti 
virus software suite.

On startup, Sophie initializes SAVI (Sophos Anti-Virus Interface), loads 
virus patterns into memory, opens local UNIX domain socket, and waits for 
someone to connect and instructs it which path to scan. Since it is loaded 
in RAM, scanning is very fast. Of course, speed of scanning also depends on 
SAVI settings and size of the file. 

%prep
rm -rf $RPM_BUILD_ROOT
%setup
%configure

%build
make

%install
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m 755 sophie $RPM_BUILD_ROOT%{_bindir}/

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/sophie
install -m 644 etc/sophie.cfg $RPM_BUILD_ROOT%{_sysconfdir}/
install -m 644 etc/sophie.savi $RPM_BUILD_ROOT%{_sysconfdir}/

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
install -m 644 sophie.8 $RPM_BUILD_ROOT%{_mandir}/man8

%clean
#rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc Changes Credits LICENSE README README.NETWORK eicar.com

%{_bindir}/sophie
%{_sysconfdir}/rc.d/init.d/sophie
%{_sysconfdir}/sophie.*
%{_mandir}/man8/sophie.8.gz
