#! /bin/bash

SAV_DIR='/opt/sophos-av'
SOPHIE_TMP='/tmp/sophie'
SAVI_MANIFEST='cidsync.upd'
SAVI_MANIFEST_DIR="$SAV_DIR/update/cache/LOCAL/PACKAGE/savi"

# Check for the existence of the chosen tmp directory.
if [ ! -d $SOPHIE_TMP ] ; then
    mkdir $SOPHIE_TMP
fi

# If there's already a manifest file in the temp directory, compare it with
# the one installed with SAV. If it's the same, there has been no update.
if [ -f "$SOPHIE_TMP/$SAVI_MANIFEST" ] ; then
    if diff "$SOPHIE_TMP/$SAVI_MANIFEST" "$SAVI_MANIFEST_DIR/$SAVI_MANIFEST" >/dev/null 2>&1 ; then 
        exit
    fi
fi

# Take a copy of the manifest file to compare next time we run
cp -f $SAVI_MANIFEST_DIR/$SAVI_MANIFEST $SOPHIE_TMP/$SAVI_MANIFEST

# If no Sophie config file has been specified, use a default
SOPHIE_CFG=$1
if [ "$SOPHIE_CFG" == "" ] ; then

    SOPHIE_CFG=/etc/sophie.cfg
fi

# Check for the existence of the Sophie config file
if [ -f $SOPHIE_CFG ] ; then

# Read the Sophie pid filename from the config file
    SOPHIE_PIDFILE=`cat $SOPHIE_CFG | grep ^pidfile\: | sed -e 's/pidfile: //'`

    if [ -f $SOPHIE_PIDFILE ] ; then
    
# Get the pid from the pidfile and send the signal
        for i in `cat $SOPHIE_PIDFILE` ; do
            logger -t sophie_reload Sending SIGHUP to pid $i
            kill -HUP $i
        done
    else
        logger -t sophie_reload No sophie running at $SOPHIE_PIDFILE
    fi
else
    logger -t sophie_reload No sophie config file at $SOPHIE_CFG
fi
