#!/usr/bin/perl

use IO::Socket;
use strict;
$|=1;

my $response;
my $sockname = $ARGV[0] || die "Usage: $0 <sophie_socket>\n";
#print "INPUT PATH (FILE OR DIR) TO SCAN: ";
my $path = $ARGV[1] || die "Usage: $0 <sophie_socket> <file>\n"; 
print "Scanning $path to $sockname\n";

socket(\*sock, AF_UNIX, SOCK_STREAM, 0) || die "Couldn't create socket ($!)\n";
connect(\*sock, pack_sockaddr_un $sockname) || die "Couldn't connect() to the socket ($!)\n";

syswrite(\*sock, $path, length($path));
sysread(\*sock, $response, 256);
close(\*sock);

$path =~ s/[\r\n]//g;
if ($response =~ m/^1/)
{
	print "FILE/DIR INFECTED : [$path]\n";
	if ($response =~ m/^1:.*$/)
	{
		my ($virus) = ($response =~ m/^1:(.*)$/);
		print "VIRUS FOUND   : [$virus]\n";
	}
}
elsif ($response == -1)
{
	print "UNKNOWN STATUS: [$path]\n";
}
elsif ($response == 0)
{
	print "FILE/DIR IS CLEAN : [$path]\n";
}
else
{
	print "OOOOOUPS!     : [$path]\n";
}
