/*
 * cvinfoc.h (JAN-2006)
 *
 * This file is a part of the Sophos Anti-Virus Interface (SAVI)(tm).
 *
 * Copyright (C) 2006 Sophos Plc, Oxford, England.
 * All rights reserved.
 *
 * This source code is only intended as a supplement to the
 * SAVI(tm) Reference and related documentation for the library.
 *
 * Sophos CIQueryLoadedProtection and related declarations.
 */

#ifndef __CVINFOC_DOT_H__
#define __CVINFOC_DOT_H__

#include "sav_if/csavi3c.h"

typedef struct _CIQueryLoadedProtectionVtbl
{
  CISWEEPUNKNOWN2VTBL;
  HRESULT (SOPHOS_STDCALL_PUBLIC_PTR GetMatchingIdentities)(void *object, LPCOLESTR pIdentityName, REFIID IdListIID, void** ppIdList, U32* pMatchingIdCount);
  HRESULT (SOPHOS_STDCALL_PUBLIC_PTR GetAllIdentities)(void *object, REFIID IdListIID, void** ppIdList, U32* pMatchingIdCount);
  HRESULT (SOPHOS_STDCALL_PUBLIC_PTR GetSingleIdentity)(void *object, LPCOLESTR pIdentityName, REFIID IdentityIID, void** ppIdentity);
} CIQueryLoadedProtectionVtbl;

typedef struct _CIQueryLoadedProtection
{
  CIQueryLoadedProtectionVtbl*     pVtbl;
} CIQueryLoadedProtection;

#define CIIDENTITYINFOVTBL \
  HRESULT (SOPHOS_STDCALL_PUBLIC_PTR GetName)(void* object, U32 ArraySize, LPOLESTR pName, U32* pNameLength); \
  HRESULT (SOPHOS_STDCALL_PUBLIC_PTR GetNameWithoutType)(void* object, U32 ArraySize, LPOLESTR pName, U32* pNameLength); \
  HRESULT (SOPHOS_STDCALL_PUBLIC_PTR IsVariant)(void* object, U32* pVariant); \
  HRESULT (SOPHOS_STDCALL_PUBLIC_PTR IsFamily)(void* object, U32* pFamily)


typedef struct _CIIdentityInfoVtbl
{
  CISWEEPUNKNOWN2VTBL;
  CIIDENTITYINFOVTBL;
} CIIdentityInfoVtbl;

typedef struct _CIIdentityInfo
{
  CIIdentityInfoVtbl*     pVtbl;
} CIIdentityInfo;


/* Enumeration interface for IIdentityInfo. */
typedef struct _CIEnumIdentityInfoVtbl
{
  CISWEEPUNKNOWN2VTBL;
  CIENUMVTBL;
} CIEnumIdentityInfoVtbl;
typedef struct _CIEnumIdentityInfo
{
  CIEnumIdentityInfoVtbl*     pVtbl;
} CIEnumIdentityInfo;


#endif /* __CVINFOC_DOT_H__ */
