/*
 * swerror2.h (02-NOV-2000)
 *
 * This file is a part of the Sophos Anti-Virus Interface (SAVI)(tm).
 *
 * Copyright (C) 2002 Sophos Plc, Oxford, England.
 * All rights reserved.
 *
 * This source code is only intended as a supplement to the
 * SAVI(tm) Reference and related documentation for the library.
 *
 * SAVI error code definitions.
 * NB This file is provided for backward compatibilty only. 
 * If possible include savierr.h only.
 */

#ifndef __SWERROR2_DOT_H__
#define __SWERROR2_DOT_H__

#include "savierr.h"  

/* For backward compatibility... */
#define SOPHOS_SAVI2_ERROR_INITIALISING               SOPHOS_SAVI_ERROR_INITIALISING 
#define SOPHOS_SAVI2_ERROR_TERMINATING                SOPHOS_SAVI_ERROR_TERMINATING 
#define SOPHOS_SAVI2_ERROR_SWEEPFAILURE               SOPHOS_SAVI_ERROR_SWEEPFAILURE 
#define SOPHOS_SAVI2_ERROR_VIRUSPRESENT               SOPHOS_SAVI_ERROR_VIRUSPRESENT 
#define SOPHOS_SAVI2_ERROR_NOT_INITIALISED            SOPHOS_SAVI_ERROR_NOT_INITIALISED 
#define SOPHOS_SAVI2_ERROR_IC_INCOMPATIBLE_VERSION    SOPHOS_SAVI_ERROR_IC_INCOMPATIBLE_VERSION 
#define SOPHOS_SAVI2_ERROR_IC_ACCESS_DENIED           SOPHOS_SAVI_ERROR_IC_ACCESS_DENIED
#define SOPHOS_SAVI2_ERROR_IC_SCAN_PREVENTED          SOPHOS_SAVI_ERROR_IC_SCAN_PREVENTED
#define SOPHOS_SAVI2_ERROR_DISINFECTION_FAILED        SOPHOS_SAVI_ERROR_DISINFECTION_FAILED
#define SOPHOS_SAVI2_ERROR_DISINFECTION_UNAVAILABLE   SOPHOS_SAVI_ERROR_DISINFECTION_UNAVAILABLE
#define SOPHOS_SAVI2_ERROR_UPGRADE_FAILED             SOPHOS_SAVI_ERROR_UPGRADE_FAILED
#define SOPHOS_SAVI2_ERROR_SAV_NOT_INSTALLED          SOPHOS_SAVI_ERROR_SAV_NOT_INSTALLED
#define SOPHOS_SAVI2_ERROR_INVALID_CONFIG_NAME        SOPHOS_SAVI_ERROR_INVALID_CONFIG_NAME
#define SOPHOS_SAVI2_ERROR_INVALID_CONFIG_TYPE        SOPHOS_SAVI_ERROR_INVALID_CONFIG_TYPE
#define SOPHOS_SAVI2_ERROR_INIT_CONFIGURATION         SOPHOS_SAVI_ERROR_INIT_CONFIGURATION
#define SOPHOS_SAVI2_ERROR_NOT_SUPPORTED              SOPHOS_SAVI_ERROR_NOT_SUPPORTED
#define SOPHOS_SAVI2_ERROR_COULD_NOT_OPEN             SOPHOS_SAVI_ERROR_COULD_NOT_OPEN
#define SOPHOS_SAVI2_ERROR_FILE_COMPRESSED            SOPHOS_SAVI_ERROR_FILE_COMPRESSED
#define SOPHOS_SAVI2_ERROR_FILE_ENCRYPTED             SOPHOS_SAVI_ERROR_FILE_ENCRYPTED
#define SOPHOS_SAVI2_ERROR_INFORMATION_NOT_AVAILABLE  SOPHOS_SAVI_ERROR_INFORMATION_NOT_AVAILABLE
#define SOPHOS_SAVI2_ERROR_ALREADY_INIT               SOPHOS_SAVI_ERROR_ALREADY_INIT
#define SOPHOS_SAVI2_ERROR_STUB                       SOPHOS_SAVI_ERROR_STUB
#define SOPHOS_SAVI2_ERROR_BUFFER_TOO_SMALL           SOPHOS_SAVI_ERROR_BUFFER_TOO_SMALL
#define SOPHOS_SAVI2_CBCK_CONTINUE_THIS               SOPHOS_SAVI_CBCK_CONTINUE_THIS
#define SOPHOS_SAVI2_CBCK_CONTINUE_NEXT               SOPHOS_SAVI_CBCK_CONTINUE_NEXT
#define SOPHOS_SAVI2_CBCK_STOP                        SOPHOS_SAVI_CBCK_STOP
#define SOPHOS_SAVI2_ERROR_CORRUPT                    SOPHOS_SAVI_ERROR_CORRUPT
#define SOPHOS_SAVI2_ERROR_REENTRANCY                 SOPHOS_SAVI_ERROR_REENTRANCY
#define SOPHOS_SAVI2_ERROR_CALLBACK                   SOPHOS_SAVI_ERROR_CALLBACK
#define SOPHOS_SAVI2_ERROR_PARTIAL_INFORMATION        SOPHOS_SAVI_ERROR_PARTIAL_INFORMATION
#define SOPHOS_SAVI2_ERROR_OLD_VIRUS_DATA             SOPHOS_SAVI_ERROR_OLD_VIRUS_DATA
#define SOPHOS_SAVI2_ERROR_INVALID_TMP                SOPHOS_SAVI_ERROR_INVALID_TMP
#define SOPHOS_SAVI2_ERROR_MISSING_MAIN_VIRUS_DATA    SOPHOS_SAVI_ERROR_MISSING_MAIN_VIRUS_DATA
#define SOPHOS_SAVI2_INFO_IC_ACTIVE                   SOPHOS_SAVI_INFO_IC_ACTIVE
#define SOPHOS_SAVI2_ERROR_VIRUS_DATA_INVALID_VER     SOPHOS_SAVI_ERROR_VIRUS_DATA_INVALID_VER
#define SOPHOS_SAVI2_ERROR_MUST_REINIT                SOPHOS_SAVI_ERROR_MUST_REINIT
#define SOPHOS_SAVI2_ERROR_CANNOT_SET_OPTION          SOPHOS_SAVI_ERROR_CANNOT_SET_OPTION
#define SOPHOS_SAVI2_ERROR_PART_VOL                   SOPHOS_SAVI_ERROR_PART_VOL

#endif   /*__SWERROR2_DOT_H__*/
